<template>
  <div>
    <v-card>
      <v-toolbar color="grey" dark>
        <v-toolbar-title class="white--text">
          LISTA DE RUTAS DE LA PLATAFORMA
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                v-bind="attrs"
                v-on="on"
                fab
                class="white--text"
                color="primary"
                bottom
                right
                absolute
                @click="dialogSincronizar = true"
              >
                <v-icon>mdi-sync</v-icon>
              </v-btn>
            </template>
            <span>Sincronizar rutas</span>
          </v-tooltip>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          label="Buscar"
          flat
          class="mr-16"
          dark
          solo-inverted
          append-icon="mdi-magnify"
          hide-details
          clear-icon="mdi-close-circle-outline"
        ></v-text-field>
      </v-toolbar>
      <v-list two-line subheader>
        <v-subheader>
          <v-badge
            color="grey"
            dark
            inline
            :value="searchResult.length"
            :content="searchResult.length"
          >
            <span class="pt-2">RUTAS</span>
          </v-badge>
        </v-subheader>
        <v-list-item-group
          v-model="selectedItem"
          style="overflow: auto;max-height:500px; min-height:500px"
          color="primary"
        >
          <v-divider />
          <template v-for="(item, indexItem) in searchResult">
            <v-list-item :key="indexItem" link>
              <v-list-item-avatar>
                <v-icon color="grey lighten-1" x-large>mdi-link-variant</v-icon>
              </v-list-item-avatar>
              <v-list-item-content>
                <v-list-item-title>
                  {{ item.nombre }}
                </v-list-item-title>
                <v-list-item-subtitle>
                  {{ item.rutaAbsoluta }}
                </v-list-item-subtitle>
              </v-list-item-content>
            </v-list-item>
            <v-divider :key="'divider-' + indexItem" />
          </template>
        </v-list-item-group>
      </v-list>
    </v-card>
    <template>
      <v-dialog v-model="dialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh! Advertencia</strong>
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¿Seguro que deseas
              <strong>eliminar</strong> la ruta?
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                :class="[{ desac: deletingComponente }]"
                @click="deleteRuta()"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSincronizar" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh! Advertencia</strong>
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¿Seguro que deseas
              <strong>sincronizar</strong> las rutas?
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogSincronizar = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                :class="[{ desac: syncingComponente }]"
                @click="ucRutas()"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import moment from "moment";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaRutas",
  data: (vm) => ({
    data: [],
    dialogDelete: false,
    itemToDelete: null,
    dialogSincronizar: false,
    deletingComponente: false,
    syncingComponente: false,
    loading: false,
    caseSensitive: false,
    search: null,
    selectedItem: null,
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchResult() {
      let tempData = this.data;
      if (this.search != "" && this.search) {
        tempData = tempData.filter((item) => {
          return item.nombre.toUpperCase().includes(this.search.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.nombre.toLowerCase();
          let fb = b.nombre.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    toEditRuta(ruta) {
      return {
        name: "accesos_sistema_rutas_nueva",
        params: {
          ruta: this.serviceCommons.objectToBase64(ruta),
        },
      };
    },
    deleteRuta() {
      this.deletingComponente = true;
      this.itemToDelete.id_empleado_modifica = user.empleado;
      axios
        .delete("/accesos/sistema/rutas/v1/" + this.itemToDelete.idRuta)
        .then((response) => {
          if (response) {
            let data = response.data;
            if (data) {
              this.dialogDelete = false;
              this.getRutas();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          this.deletingComponente = false;
          this.itemToDelete = null;
        });
    },
    ucRutas() {
      const routes = [];
      this.$router.options.routes.forEach((route) => {
        let idRuta = null;
        let rutaTemp = this.data.filter(
          (ruta) => ruta.nombre === route.name
        )[0];
        if (rutaTemp) {
          idRuta = rutaTemp.idRuta;
        }
        routes.push({
          rutaAbsoluta: route.path,
          nombre: route.name,
          idRuta,
        });
      });
      this.syncingComponente = true;
      axios
        .patch("/accesos/sistema/rutas/v1/", routes)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.getRutas();
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          this.dialogSincronizar = false;
          this.syncingComponente = false;
        });
    },
    getRutas() {
      this.loading = true;
      axios("/accesos/sistema/rutas/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = data.resultado.rutas;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.getRutas();
  },
};
</script>
